var Grouper = require('../lib/stepper').Grouper;

var grouper = new Grouper();

// setup group functions
grouper.add(function(fn) {
    console.log('running step 1 (async)');
    console.log('wait 3 seconds...');
    setTimeout(function() {
        console.log('completed step 1 (async)');
        fn(null, 1);
    }, (1000 * 3));
});
grouper.add(function(fn) {
    console.log('running step 2 (async)');
    console.log('wait 2 seconds...');
    setTimeout(function() {
        console.log('completed step 2 (async)');
        fn(null, 2);
    }, (1000 * 2));
});
grouper.add(function(fn) {
    console.log('running step 3 (async)');
    console.log('wait 1 second...');
    setTimeout(function() {
        console.log('completed step 3 (async)');
        fn(null, 3);
    }, (1000));
});

// handle completion
var onComplete = function(err, vals) {
    if (err) throw err;
    console.log('group is complete');
    console.log('return values: ' + vals + '\n');
};

// run steps
console.log('\nstart group...');
grouper.walk(onComplete);
