var Stepper = require('../lib/stepper').Stepper;

var stepper = new Stepper();

// add steps
stepper.add(function(err, val) {
    console.log('running step 1 (sync)');
    return 1;
});
stepper.add(function(err, val) {
    if (err) throw err;
    console.log('running step 2 (sync)');
    return 2;
});
stepper.add(function(err, val) {
    if (err) throw err;
    console.log('running step 3 (async)');
    var self = this;
    console.log('wait 2 seconds...');
    setTimeout(function() {
        console.log('completed step 3 (async)');
        self();
    }, 2000);
});
stepper.add(function(err, val) {
    console.log('running step 4 (sync)');
    return 4;
});

// handle completion
var onComplete = function(err, val) {
    if (err) throw err;
    console.log('stepping is complete');
    console.log('return value: ' + val + '\n');    
};

// run steps
console.log('\nstart stepping...');
stepper.walk(onComplete);
